import { DependencyInfo, ILifetime } from '../Lifetime';
import { Key, LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
declare type Falsy = null | undefined | false | 0 | '';
export declare class ScopedServiceProvider<E = any> implements IServiceProvider<E> {
    readonly scope: Record<Key<any>, any>;
    private readonly singletons;
    private readonly lookup;
    private readonly ordered;
    readonly lifetimes: LifetimeCollection<E>;
    readonly proxy: E;
    readonly root: IServiceProvider<E>;
    readonly parent: IServiceProvider<E>;
    constructor(parent: IServiceProvider<E>, lifetime?: ILifetime);
    private _isDone;
    get isDone(): boolean;
    get depth(): number;
    get lastSingleton(): DependencyInfo<E> | undefined;
    provide<T>(selector: Selector<T, E>): T;
    enter(lifetime: ILifetime | Falsy): ScopedServiceProvider<E>;
    private _enter;
    private getLifetime;
}
export {};
